
format PE GUI 4.0
entry start

include 'inc\win32a.inc'

ID_LOG     = 101
ID_TXT     = 102
ID_INFO    = 103
ID_START   = 104
ID_STOP    = 105
ID_ENABLE  = 106
ID_DISABLE = 107
ID_DELETE  = 108

;---------------------------------------------

section '.data' data readable writeable

SC_MANAGER_ALL_ACCESS = 0xF003F
SERVICE_ALL_ACCESS    = 0xF01FF
SERVICE_QUERY_CONFIG  = 0x0001
SERVICE_QUERY_STATUS  = 0x0004
SERVICE_CHANGE_CONFIG = 0x0002
SERVICE_START         = 0x0010
SERVICE_STOP          = 0x0020
DELETE                = 0x10000
SERVICE_NO_CHANGE     = 0xFFFFFFFF
SERVICE_CONTROL_STOP  = 0x00000001
SERVICE_WIN32_OWN_PROCESS   = 0x00000010
SERVICE_WIN32_SHARE_PROCESS = 0x00000020
SERVICE_ACTIVE        = 0x00000001
SERVICE_INACTIVE      = 0x00000002

SERVICE_STOPPED          = 0x00000001
SERVICE_START_PENDING    = 0x00000002
SERVICE_STOP_PENDING     = 0x00000003
SERVICE_RUNNING          = 0x00000004
SERVICE_CONTINUE_PENDING = 0x00000005
SERVICE_PAUSE_PENDING    = 0x00000006
SERVICE_PAUSED           = 0x00000007

SERVICE_BOOT_START   = 0x00000000
SERVICE_SYSTEM_START = 0x00000001
SERVICE_AUTO_START   = 0x00000002
SERVICE_DEMAND_START = 0x00000003
SERVICE_DISABLED     = 0x00000004

struct SERVICE_STATUS
        dwServiceType      dd ?
        dwCurrentState     dd ?
        dwControlsAccepted dd ?
        dwWin32ExitCode    dd ?
        dwServiceSpecificExitCode dd ?
        dwCheckPoint       dd ?
        dwWaitHint         dd ?
ends

struct QUERY_SERVICE_CONFIG
        dwServiceType      dd ?
        dwStartType        dd ?
        dwErrorControl     dd ?
        lpBinaryPathName   dd ?
        lpLoadOrderGroup   dd ?
        dwTagId            dd ?
        lpDependencies     dd ?
        lpServiceStartName dd ?
        lpDisplayName      dd ?
ends

struct QUERY_SERVICE_LOCK_STATUS
        fIsLocked      dd ?
        lpLockOwner    dd ?
        dwLockDuration dd ?
ends

mask    du 'ServiceName: %s',13,10
        du 'DisplayName: %s',13,10
        du 'Status: %s',13,10
        du 'BinaryPathName: %s',13,10
        du 'ServiceStartName: %s',13,10
        du 'StartType: %s',13,10
        du 'Dependencies: %s',13,10
        du 0

stStr   dd 0
        dd szSt1
        dd szSt2
        dd szSt3
        dd szSt4
        dd szSt5
        dd szSt6
        dd szSt7

szSt1   du 'service is not running',0
szSt2   du 'service is starting',0
szSt3   du 'service is stopping',0
szSt4   du 'service is running',0
szSt5   du 'service continue is pending',0
szSt6   du 'service pause is pending',0
szSt7   du 'service is paused',0

ssStr   dd szSs0
        dd szSs1
        dd szSs2
        dd szSs3
        dd szSs4

szSs0   du 'SERVICE_BOOT_START',0
szSs1   du 'SERVICE_SYSTEM_START',0
szSs2   du 'SERVICE_AUTO_START',0
szSs3   du 'SERVICE_DEMAND_START',0
szSs4   du 'SERVICE_DISABLED',0

hwmain  dd ?
buff    rw 500h

scm     dd ?
BytesNeeded dd ?

tmp      dd ?

mem      dd ?
mem2     dd ?
Status   dd ?
hService dd ?
Service  dd ?
LockDB   dd ?
ScLock   dd ?

TickCount dd ?
CheckPoint dd ?

sname   rw 500h

;---------------------------------------------

section '.code' code readable executable

  start:
        invoke  GetModuleHandle,0
        invoke  DialogBoxParam,eax,1,HWND_DESKTOP,DialogProc,0
loc_exit:
        invoke  ExitProcess,0

;---------------------------------------------

proc DialogProc hwnddlg,msg,wparam,lparam
        push    ebx esi edi
        cmp     [msg],WM_INITDIALOG
        je      wminitdialog
        cmp     [msg],WM_COMMAND
        je      wmcommand
        cmp     [msg],WM_CLOSE
        je      wmclose

        xor     eax,eax
        jmp     finish
  wminitdialog:
        mov     eax,[hwnddlg]
        mov     [hwmain],eax

        ;   
        invoke  SendDlgItemMessage,[hwnddlg],ID_LOG,EM_SETLIMITTEXT,2000000,0

int 3

        ;   
        invoke  OpenSCManager,NULL,NULL,SC_MANAGER_ALL_ACCESS
        or      eax,eax
        jz      wmclose

        mov     [scm],eax
        jmp     processed

;---------------------------------------------------------------------------
;    
;---------------------------------------------------------------------------
info_service:
        invoke  SetDlgItemText,[hwnddlg],ID_LOG,NULL
        invoke  GetDlgItemText,[hwnddlg],ID_TXT,sname,500h

        ;  
        invoke  OpenService,[scm],sname,SERVICE_QUERY_CONFIG+SERVICE_QUERY_STATUS
        or      eax,eax
        jnz     info_service_ok1

        call    @f
        du      'ERROR: OpenService',13,10,0
@@:
        stdcall AddLog,[hwnddlg],ID_LOG
        jmp     processed
info_service_ok1:
        mov     [hService],eax

        ;  
        invoke  GlobalAlloc,GMEM_FIXED+GMEM_ZEROINIT,sizeof.SERVICE_STATUS
        mov     [mem2],eax
        invoke  GlobalLock,eax
        mov     [Status],eax

        invoke  QueryServiceStatus,[hService],[Status]
        or      eax,eax
        jnz     info_service_ok2

        call    @f
        du      'ERROR: QueryServiceStatus',13,10,0
@@:
        stdcall AddLog,[hwnddlg],ID_LOG
        jmp     loc_info_done2
info_service_ok2:
        mov     ebx,[Status]

        ;    
        invoke  QueryServiceConfig,[hService],NULL,0,BytesNeeded

        cmp     [BytesNeeded],0
        jnz     info_service_ok3

        call    @f
        du      'ERROR: QueryServiceConfig (1)',13,10,0
@@:
        stdcall AddLog,[hwnddlg],ID_LOG
        jmp     loc_info_done2

info_service_ok3:
        ;  
        invoke  GlobalAlloc,GMEM_FIXED+GMEM_ZEROINIT,[BytesNeeded]
        mov     [mem2],eax
        invoke  GlobalLock,eax
        mov     [Service],eax

        ;   
        invoke  QueryServiceConfig,[hService],[Service],[BytesNeeded],BytesNeeded
        or      eax,eax
        jnz     info_service_ok4

        call    @f
        du      'ERROR: QueryServiceConfig (2)',13,10,0
@@:
        stdcall AddLog,[hwnddlg],ID_LOG
        jmp     loc_info_done1

info_service_ok4:
        ;    QUERY_SERVICE_CONFIG
        mov     ecx,[Service]

        ; 
        mov     edx,[ecx+QUERY_SERVICE_CONFIG.lpDependencies]
        push    edx

        ;  
        mov     edx,[ecx+QUERY_SERVICE_CONFIG.dwStartType]
        shl     edx,2
        mov     edx,[ssStr+edx]
        push    edx

        ;   
        mov     edx,[ecx+QUERY_SERVICE_CONFIG.lpServiceStartName]
        push    edx

        ;   
        mov     edx,[ecx+QUERY_SERVICE_CONFIG.lpBinaryPathName]
        push    edx

loc_write_service:
        ;  
        mov     edx,[ebx+SERVICE_STATUS.dwCurrentState]
        shl     edx,2
        mov     edx,[stStr+edx]
        push    edx

        invoke  wsprintf,buff,mask,\
                sname,\
                [ecx+QUERY_SERVICE_CONFIG.lpDisplayName]
        add     esp,36

        stdcall AddLog,[hwnddlg],ID_LOG,buff

        ;  
loc_info_done1:
        invoke  GlobalUnlock,[Service]
        invoke  GlobalFree,[mem2]
loc_info_done2:
        invoke  GlobalUnlock,[Status]
        invoke  GlobalFree,[mem]

        ;  
        invoke  CloseServiceHandle,[hService]

        jmp     processed

;---------------------------------------------------------------------------
;    ()
;---------------------------------------------------------------------------
disable_service:
        invoke  SetDlgItemText,[hwnddlg],ID_LOG,NULL
        invoke  GetDlgItemText,[hwnddlg],ID_TXT,sname,500h

        ;  
        invoke  OpenService,[scm],sname,SERVICE_CHANGE_CONFIG
        or      eax,eax
        jnz     disable_service_ok1

        call    @f
        du      'ERROR: OpenService',13,10,0
@@:
        stdcall AddLog,[hwnddlg],ID_LOG
        jmp     processed
disable_service_ok1:

        mov     [hService],eax

        ;    
        invoke  QueryServiceLockStatus,[scm],NULL,0,BytesNeeded
        add     [BytesNeeded],100

        ;  
        invoke  GlobalAlloc,GMEM_FIXED+GMEM_ZEROINIT,[BytesNeeded]
        mov     [mem],eax
        invoke  GlobalLock,eax
        mov     [LockDB],eax

disable_service_wait:
        invoke  QueryServiceLockStatus,[scm],[LockDB],[BytesNeeded],tmp
        mov     eax,[LockDB]
        cmp     [eax+QUERY_SERVICE_LOCK_STATUS.fIsLocked],0
        je      disable_service_lock

        call    @f
        du      'Waiting for database...',13,10,0
@@:
        stdcall AddLog,[hwnddlg],ID_LOG

        invoke  Sleep,1000
        jmp     disable_service_wait

disable_service_lock:
        ;  
        invoke  GlobalUnlock,[LockDB]
        invoke  GlobalFree,[mem]

        ;  
        invoke  LockServiceDatabase,[scm]
        mov     [ScLock],eax

        ;  
        invoke  ChangeServiceConfig,[hService],\
                SERVICE_NO_CHANGE,SERVICE_DISABLED,\
                SERVICE_NO_CHANGE,NULL,NULL,NULL,NULL,\
                NULL,NULL,NULL
        or      eax,eax
        jnz     disable_service_ok2

        call    @f
        du      'ERROR: ChangeServiceConfig',13,10,0
@@:
        stdcall AddLog,[hwnddlg],ID_LOG
        jmp     disable_service_done

disable_service_ok2:
        call    @f
        du      'Done',13,10,0
@@:
        stdcall AddLog,[hwnddlg],ID_LOG

disable_service_done:
        ;  
        invoke  CloseServiceHandle,[hService]

        ;  
        invoke  UnlockServiceDatabase,[ScLock]

        jmp     processed

;---------------------------------------------------------------------------
;    ()
;---------------------------------------------------------------------------
enable_service:
        invoke  SetDlgItemText,[hwnddlg],ID_LOG,NULL
        invoke  GetDlgItemText,[hwnddlg],ID_TXT,sname,500h

        ;  
        invoke  OpenService,[scm],sname,SERVICE_CHANGE_CONFIG
        or      eax,eax
        jnz     enable_service_ok1

        call    @f
        du      'ERROR: OpenService',13,10,0
@@:
        stdcall AddLog,[hwnddlg],ID_LOG
        jmp     processed
enable_service_ok1:

        mov     [hService],eax

        ;    
        invoke  QueryServiceLockStatus,[scm],NULL,0,BytesNeeded
        add     [BytesNeeded],100

        ;  
        invoke  GlobalAlloc,GMEM_FIXED+GMEM_ZEROINIT,[BytesNeeded]
        mov     [mem],eax
        invoke  GlobalLock,eax
        mov     [LockDB],eax

enable_service_wait:
        invoke  QueryServiceLockStatus,[scm],[LockDB],[BytesNeeded],tmp
        mov     eax,[LockDB]
        cmp     [eax+QUERY_SERVICE_LOCK_STATUS.fIsLocked],0
        je      enable_service_lock

        call    @f
        du      'Waiting for database...',13,10,0
@@:
        stdcall AddLog,[hwnddlg],ID_LOG

        invoke  Sleep,1000
        jmp     enable_service_wait

enable_service_lock:
        ;  
        invoke  GlobalUnlock,[LockDB]
        invoke  GlobalFree,[mem]

        ;  
        invoke  LockServiceDatabase,[scm]
        mov     [ScLock],eax

        ;  
        invoke  ChangeServiceConfig,[hService],\
                SERVICE_NO_CHANGE,SERVICE_AUTO_START,\
                SERVICE_NO_CHANGE,NULL,NULL,NULL,NULL,\
                NULL,NULL,NULL
        or      eax,eax
        jnz     enable_service_ok2

        call    @f
        du      'ERROR: ChangeServiceConfig',13,10,0
@@:
        stdcall AddLog,[hwnddlg],ID_LOG
        jmp     enable_service_done

enable_service_ok2:
        call    @f
        du      'Done',13,10,0
@@:
        stdcall AddLog,[hwnddlg],ID_LOG

enable_service_done:
        ;  
        invoke  CloseServiceHandle,[hService]

        ;  
        invoke  UnlockServiceDatabase,[ScLock]

        jmp     processed

;---------------------------------------------------------------------------
;  
;---------------------------------------------------------------------------
stop_service:
        invoke  SetDlgItemText,[hwnddlg],ID_LOG,NULL
        invoke  GetDlgItemText,[hwnddlg],ID_TXT,sname,500h

        ;  
        invoke  OpenService,[scm],sname,SERVICE_STOP+SERVICE_QUERY_STATUS
        or      eax,eax
        jnz     stop_service_ok1

        call    @f
        du      'ERROR: OpenService',13,10,0
@@:
        stdcall AddLog,[hwnddlg],ID_LOG
        jmp     processed
stop_service_ok1:

        mov     [hService],eax

        invoke  ControlService,[hService],SERVICE_CONTROL_STOP
        or      eax,eax
        jnz     stop_service_ok2

        call    @f
        du      'ERROR: ControlService',13,10,0
@@:
        stdcall AddLog,[hwnddlg],ID_LOG
        jmp     stop_service_done2
stop_service_ok2:

        ;  
        invoke  GlobalAlloc,GMEM_FIXED+GMEM_ZEROINIT,sizeof.SERVICE_STATUS
        mov     [mem],eax
        invoke  GlobalLock,eax
        mov     [Status],eax

        invoke  QueryServiceStatus,[hService],[Status]
        or      eax,eax
        jnz     stop_service_ok3

        call    @f
        du      'ERROR: QueryServiceStatus',13,10,0
@@:
        stdcall AddLog,[hwnddlg],ID_LOG
        jmp     stop_service_done1
stop_service_ok3:

        mov     ebx,[Status]

        invoke  GetTickCount
        mov     [TickCount],eax

        mov     eax,[ebx+SERVICE_STATUS.dwCheckPoint]
        mov     [CheckPoint],eax

stop_service_wait:
        cmp     [ebx+SERVICE_STATUS.dwCurrentState],SERVICE_STOP_PENDING
        jne     stop_service_wait_done

        mov     eax,[ebx+SERVICE_STATUS.dwWaitHint]
        xor     edx,edx
        mov     ecx,10
        div     ecx

        cmp     eax,1000
        ja      @f
        mov     eax,1000
@@:
        cmp     eax,10000
        jb      @f
        mov     eax,10000
@@:
        call    @f
        du      'Waiting...',13,10,0
@@:
        stdcall AddLog,[hwnddlg],ID_LOG

        invoke  Sleep,eax

        invoke  QueryServiceStatus,[hService],[Status]

        mov     eax,[ebx+SERVICE_STATUS.dwCheckPoint]
        cmp     eax,[CheckPoint]
        jbe     @f

        invoke  GetTickCount
        mov     [TickCount],eax

        mov     eax,[ebx+SERVICE_STATUS.dwCheckPoint]
        mov     [CheckPoint],eax
        jmp     stop_service_wait
@@:
        invoke  GetTickCount
        sub     eax,[TickCount]
        cmp     eax,[ebx+SERVICE_STATUS.dwWaitHint]
        jb      stop_service_wait

stop_service_wait_done:
        cmp     [ebx+SERVICE_STATUS.dwCurrentState],SERVICE_STOPPED
        je      stop_service_done

        call    @f
        du      'Service stop error',13,10,0
@@:
        stdcall AddLog,[hwnddlg],ID_LOG
        jmp     stop_service_done1

stop_service_done:
        call    @f
        du      'Done',13,10,0
@@:
        stdcall AddLog,[hwnddlg],ID_LOG

stop_service_done1:
        ;  
        invoke  GlobalUnlock,[Status]
        invoke  GlobalFree,[mem]

stop_service_done2:
        ;  
        invoke  CloseServiceHandle,[hService]

        jmp     processed

;---------------------------------------------------------------------------
;  
;---------------------------------------------------------------------------
start_service:
        invoke  SetDlgItemText,[hwnddlg],ID_LOG,NULL
        invoke  GetDlgItemText,[hwnddlg],ID_TXT,sname,500h

        ;  
        invoke  OpenService,[scm],sname,SERVICE_START+SERVICE_QUERY_STATUS
        or      eax,eax
        jnz     start_service_ok1

        call    @f
        du      'ERROR: OpenService',13,10,0
@@:
        stdcall AddLog,[hwnddlg],ID_LOG
        jmp     processed

start_service_ok1:
        mov     [hService],eax

        ;  
        invoke  StartService,[hService],0,NULL

        or      eax,eax
        jnz     start_service_ok2

        call    @f
        du      'ERROR: ControlService',13,10,0
@@:
        stdcall AddLog,[hwnddlg],ID_LOG
        jmp     start_service_done2

start_service_ok2:
        ;  
        invoke  GlobalAlloc,GMEM_FIXED+GMEM_ZEROINIT,sizeof.SERVICE_STATUS
        mov     [mem],eax
        invoke  GlobalLock,eax
        mov     [Status],eax

        invoke  QueryServiceStatus,[hService],[Status]
        or      eax,eax
        jnz     start_service_ok3

        call    @f
        du      'ERROR: QueryServiceStatus',13,10,0
@@:
        stdcall AddLog,[hwnddlg],ID_LOG
        jmp     start_service_done1

start_service_ok3:
        mov     ebx,[Status]

        invoke  GetTickCount
        mov     [TickCount],eax

        mov     eax,[ebx+SERVICE_STATUS.dwCheckPoint]
        mov     [CheckPoint],eax

start_service_wait:
        cmp     [ebx+SERVICE_STATUS.dwCurrentState],SERVICE_START_PENDING
        jne     start_service_wait_done

        mov     eax,[ebx+SERVICE_STATUS.dwWaitHint]
        xor     edx,edx
        mov     ecx,10
        div     ecx

        cmp     eax,1000
        ja      @f
        mov     eax,1000
@@:
        cmp     eax,10000
        jb      @f
        mov     eax,10000
@@:
        call    @f
        du      'Waiting...',13,10,0
@@:
        stdcall AddLog,[hwnddlg],ID_LOG

        invoke  Sleep,eax

        invoke  QueryServiceStatus,[hService],[Status]

        mov     eax,[ebx+SERVICE_STATUS.dwCheckPoint]
        cmp     eax,[CheckPoint]
        jbe     @f

        invoke  GetTickCount
        mov     [TickCount],eax

        mov     eax,[ebx+SERVICE_STATUS.dwCheckPoint]
        mov     [CheckPoint],eax
        jmp     start_service_wait
@@:
        invoke  GetTickCount
        sub     eax,[TickCount]
        cmp     eax,[ebx+SERVICE_STATUS.dwWaitHint]
        jb      start_service_wait

start_service_wait_done:
        cmp     [ebx+SERVICE_STATUS.dwCurrentState],SERVICE_RUNNING
        je      start_service_done

        call    @f
        du      'Service start error',13,10,0
@@:
        stdcall AddLog,[hwnddlg],ID_LOG
        jmp     start_service_done1

start_service_done:
        call    @f
        du      'Done',13,10,0
@@:
        stdcall AddLog,[hwnddlg],ID_LOG

start_service_done1:
        ;  
        invoke  GlobalUnlock,[Status]
        invoke  GlobalFree,[mem]

start_service_done2:
        ;  
        invoke  CloseServiceHandle,[hService]

        jmp     processed

;---------------------------------------------------------------------------
;  
;---------------------------------------------------------------------------
delete_service:
        push    MB_OKCANCEL
        call    @f
        du      'Delete',0
@@:
        call    @f
        du      'Are you sure?',0
@@:
        invoke  MessageBox,[hwnddlg]
        cmp     eax,IDOK
        jne     processed

        invoke  SetDlgItemText,[hwnddlg],ID_LOG,NULL
        invoke  GetDlgItemText,[hwnddlg],ID_TXT,sname,500h

        ;  
        invoke  OpenService,[scm],sname,DELETE
        or      eax,eax
        jnz     delete_service_ok1

        call    @f
        du      'ERROR: OpenService',13,10,0
@@:
        stdcall AddLog,[hwnddlg],ID_LOG
        jmp     processed

delete_service_ok1:
        mov     [hService],eax

        ;    
        invoke  DeleteService,[hService]
        or      eax,eax
        jnz     delete_service_ok2

        call    @f
        du      'ERROR: DeleteService',13,10,0
@@:
        stdcall AddLog,[hwnddlg],ID_LOG
        jmp     delete_service_done

delete_service_ok2:
        invoke  GetLastError

        call    @f
        du      'Done',13,10,0
@@:
        stdcall AddLog,[hwnddlg],ID_LOG

delete_service_done:
        ;  
        invoke  CloseServiceHandle,[hService]

        jmp     processed


  wmcommand:
        cmp     [wparam],BN_CLICKED shl 16 + IDCANCEL
        je      wmclose
        cmp     [wparam],BN_CLICKED shl 16 + ID_INFO
        je      info_service
        cmp     [wparam],BN_CLICKED shl 16 + ID_DISABLE
        je      disable_service
        cmp     [wparam],BN_CLICKED shl 16 + ID_ENABLE
        je      enable_service
        cmp     [wparam],BN_CLICKED shl 16 + ID_START
        je      start_service
        cmp     [wparam],BN_CLICKED shl 16 + ID_STOP
        je      stop_service
        cmp     [wparam],BN_CLICKED shl 16 + ID_DELETE
        je      delete_service
        jmp     processed

  wmclose:
        ;   
        invoke  CloseServiceHandle,[scm]

        invoke  EndDialog,[hwnddlg],0
  processed:
        mov     eax,1
  finish:
        pop     edi esi ebx
        ret
endp

;---------------------------------------------
; procedure AddLog
; void AddLog(hWnd:dword,CtrlID:dword,&string)
;---------------------------------------------
proc    AddLog  hWnd:dword,CtrlID:dword,pStr:dword
        push    eax
        invoke  GetDlgItem,[hWnd],[CtrlID]
        or      eax,eax
        jz      .AddLog_1
        mov     [CtrlID],eax
        invoke  SendMessage,[CtrlID],EM_GETLINECOUNT,0,0
        dec     eax
        invoke  SendMessage,[CtrlID],EM_LINEINDEX,eax,0
        invoke  SendMessage,[CtrlID],EM_SETSEL,eax,eax
        invoke  SendMessage,[CtrlID],EM_REPLACESEL,FALSE,[pStr]
.AddLog_1:
        pop     eax
        ret
endp

;---------------------------------------------

section '.idata' import data readable writeable

  library kernel32,'kernel32.dll',\
          shell32,'shell32.dll',\
          user32,'user32.dll',\
          advapi32,'advapi32.dll'

  include 'inc\api\kernel32.inc'
  include 'inc\api\user32.inc'
  include 'inc\api\shell32.inc'
  include 'inc\api\advapi32.inc'

;---------------------------------------------

section '.rsrc' resource data readable

  directory RT_DIALOG,dialogs

  resource dialogs,\
           1,LANG_ENGLISH+SUBLANG_DEFAULT,demonstration

  dialog demonstration,'Service Control Demo',70,70,300,200,WS_CAPTION+WS_POPUP+WS_SYSMENU+DS_MODALFRAME+DS_SYSMODAL
        dialogitem 'EDIT','Fax', ID_TXT,10,7,280,13,WS_VISIBLE+WS_BORDER+WS_TABSTOP+ES_AUTOHSCROLL
        dialogitem 'EDIT','',ID_LOG,10,23,280,155,WS_VISIBLE+WS_BORDER+ES_READONLY+ES_MULTILINE+WS_VSCROLL+WS_HSCROLL
        dialogitem 'BUTTON','Info',ID_INFO,5,181,32,15,WS_VISIBLE+WS_TABSTOP+BS_PUSHBUTTON
        dialogitem 'BUTTON','Start',ID_START,40,181,32,15,WS_VISIBLE+WS_TABSTOP+BS_PUSHBUTTON
        dialogitem 'BUTTON','Stop',ID_STOP,75,181,32,15,WS_VISIBLE+WS_TABSTOP+BS_PUSHBUTTON
        dialogitem 'BUTTON','Enable',ID_ENABLE,110,181,32,15,WS_VISIBLE+WS_TABSTOP+BS_PUSHBUTTON
        dialogitem 'BUTTON','Disable',ID_DISABLE,145,181,32,15,WS_VISIBLE+WS_TABSTOP+BS_PUSHBUTTON
        dialogitem 'BUTTON','Delete',ID_DELETE,180,181,32,15,WS_VISIBLE+WS_TABSTOP+BS_PUSHBUTTON
        dialogitem 'BUTTON','Exit',IDCANCEL,263,181,32,15,WS_VISIBLE+WS_TABSTOP+BS_PUSHBUTTON
  enddialog
